/*
Controllo processo birra

*/

// Librerie
/*The display circuit:
 * LCD RS pin to digital pin 12
 * LCD Enable pin to digital pin 11
 * LCD D4 pin to digital pin 5
 * LCD D5 pin to digital pin 4
 * LCD D6 pin to digital pin 3
 * LCD D7 pin to digital pin 2
*/ 

#include <LiquidCrystal.h>
#include <math.h>
#include <EEPROM.h>
#include <avr/io.h>
#include <avr/interrupt.h>



//Definizione I/O
LiquidCrystal lcd(12, 11, 5, 4, 3, 2);

//Ingressi
//        nome   pin
const int i_P1   = 1;   //Pulsante 1
const int i_P2   = 0;   //Pulsante 2 
const int i_P3   = 6;   //Pulsante 3 
const int i_NTC  = A0;  //Analofico NTC

//Uscite
//        nome   pin
const int o_R1   = 7;  //Relais 1
const int o_R2   = 8;  //Relais 1
const int o_R3   = 9;  //Relais 1
const int o_Cs   = 10; //Contrasto display
const int o_Ri   = 13; //Retroilluminazione     


//Inizializzazione variabili
int P1_Stato;
int P2_Stato=0;
int P3_Stato=0;
int P1_Stato_hold;
int P2_Stato_hold;
int P3_Stato_hold;
int P1_reading;
int P2_reading=0;
int P3_reading=0;
int P1_pressed;
int P1_long;
long ti=0;
int P1_lastButtonState = LOW;   
int P2_lastButtonState = LOW;   
int P3_lastButtonState = LOW;   
long P1_lastDebounceTime = 0;  
long P2_lastDebounceTime = 0;  
long P3_lastDebounceTime = 0;  
long P2_ti_temp;
long P3_ti_temp;
long P2_ti_temp_p;
long P3_ti_temp_p;
long debounceDelay = 50;
int P1_Temp;
int P2_Temp;
int P3_Temp;
int P1_Temp_s;
int P2_Temp_s;
int P3_Temp_s;
const long delay_p =200; //ritardo per variazione valore con pulsante premuto
const long delay_pp =400; //ritardo per grande variazione valore con pulsante premuto
long P2_delay_pp; //ritardo per offset grande
long P3_delay_pp;
int P2_jump;
int P3_jump;

int avvio;
int index=0;
int pagina;
int offset_p=0;
const int MaxPage         = 11;    //ultima pagina menù normale
const int FirstSecretPage = 50;  //prima pagina menù nascosto
const int MaxSecretPage   = 54;    //ultima pagina menù nascosto
const int FirstAlarmPage  = 100;  //prima pagina allarmi


double Temp    =0;
double A[3]={0.001129148, 0.001129241, 0.00102844};
double B[3]={0.000234125, 0.000234107, 0.000239243};
double C[3]={0.0000000876741, 0.000000087, 0.000000156};
          
int pag0;
int EEPROMWrite;
long EEPROMTemp;
const int MaxEEPROM       = 104;  //numero locazioni usate in EEPROM        
long memoria[MaxEEPROM];          
          
          
int Retroilluminazione_On=0;
long ti_Retroilluminazione=0;
int Tempo_Ri=1;
int Tempo_R2=1;
long time_R2_I=0;

int contrasto=100;

int offset_v=1;


int Step_A=0;
int Step_I;
int Step_F;

int S1_time;

int S1_min;
int S1_sec;
int S1_min_temp;
int S1_sec_temp;
int S2_min;
int S2_sec;
int S2_min_temp;
int S2_sec_temp;
int S3_min;
int S3_sec;
int S3_min_temp;
int S3_sec_temp;
int S4_min;
int S4_sec;
int S4_min_temp;
int S4_sec_temp;
int S5_min;
int S5_sec;
int S5_min_temp;
int S5_sec_temp;

double T1;
double T2;
double T3;
double T4;
double T5;

int T1_int;
int T2_int;
int T3_int;
int T4_int;
int T5_int;
String T1_string;
String T2_string;
String T3_string;
String T4_string;
String T5_string;

int a_T[6]={0,0,0,0,0,0};
int a_T_sec[6]={0,0,0,0,0,0};
int a_T_min[6]={0,0,0,0,0,0};

int T_sec;
int T_min;
int T_int;
String T_string;
int T_sec_hold=0;
int T_min_hold=0;

int Tolleranza;
String Tolleranza_string;

int Rele[4]={LOW, LOW, LOW, LOW};
int rele_index=1;
int f_Manuali;

int Clock1sec;
int refresh;

int Start;
String On_Off="OFF";

int stato=0;

int R1_on;
int R2_on;
int R3_on;
int R2_start;
 
int Ta_int; 
int Timeout;
int Temp_hold;
long time_Timeout_I=0;
int Timeout_start;
int No_timeout;
String Timeout_string;





void setup() {
  // set up the LCD's number of columns and rows: 
  lcd.begin(16, 2);
  
  //---------------Inizializzazione Ingressi-------------
  pinMode(i_P1, INPUT); 
  pinMode(i_P2, INPUT);   
  pinMode(i_P3, INPUT);   

  //---------------Inizializzazione uscite---------------  
  pinMode(o_R1, OUTPUT);   
  pinMode(o_R2, OUTPUT);   
  pinMode(o_R3, OUTPUT);   
  pinMode(o_Cs, OUTPUT);   
  pinMode(o_Ri, OUTPUT);     
  
  //----------Azzeramento uscite a rele-------------------
  digitalWrite(o_R1,LOW);
  digitalWrite(o_R2,LOW);
  digitalWrite(o_R3,LOW);
  
  
  //--------------Pagina benvenuto-----------------------
  digitalWrite(o_Ri,HIGH);
  lcd.setCursor(4, 0);  // colonna, riga
  lcd.print("StepMash");
  lcd.setCursor(5, 1);  // colonna, riga
  lcd.print("V.1_00");
  delay(1000);
  lcd.clear();
   
  //Recupero dati memoria
  for (int EEPROMIndexRd=0; EEPROMIndexRd<=MaxEEPROM; EEPROMIndexRd+=4 ){
    memoria[EEPROMIndexRd]=EEPROMReadInt(EEPROMIndexRd);
  }
  contrasto=int(memoria[0]);
  Tempo_Ri=int(memoria[4]);
  Step_I=int(memoria[8]);
  Step_F=int(memoria[12]);
  S1_sec=int(memoria[16]);
  S1_min=int(memoria[20]);
  S2_sec=int(memoria[24]);
  S2_min=int(memoria[28]);
  S3_sec=int(memoria[32]);
  S3_min=int(memoria[36]);
  S4_sec=int(memoria[40]);
  S4_min=int(memoria[44]);
  S5_sec=int(memoria[48]);
  S5_min=int(memoria[52]);
  T1_int=int(memoria[56]);
  T2_int=int(memoria[60]);
  T3_int=int(memoria[64]);
  T4_int=int(memoria[68]);
  T5_int=int(memoria[72]);
  T_int=int(memoria[76]);
  T_sec=int(memoria[80]);
  T_min=int(memoria[84]);
  Step_A=int(memoria[88]);
  Tolleranza=int(memoria[92]);
  stato=int(memoria[96]);
  Tempo_R2=int(memoria[100]);
  Timeout=int(memoria[104]);

  S1_sec_temp=S1_sec;
  S1_min_temp=S1_min;
  S2_sec_temp=S2_sec;
  S2_min_temp=S2_min;
  S3_sec_temp=S3_sec;
  S3_min_temp=S3_min;
  S4_sec_temp=S4_sec;
  S4_min_temp=S4_min;
  S5_sec_temp=S5_sec;
  S5_min_temp=S5_min;
 
  T1_string=IntToString(T1_int);
  T2_string=IntToString(T2_int);
  T3_string=IntToString(T3_int);
  T4_string=IntToString(T4_int);
  T5_string=IntToString(T5_int);
  
  //---------------------Aggiornamento valori step---------------------
  a_T[1]=T1_int; a_T[2]=T2_int; a_T[3]=T3_int; a_T[5]=T5_int;
  a_T_sec[1]=S1_sec; a_T_sec[2]=S2_sec; a_T_sec[3]=S3_sec; a_T_sec[4]=S4_sec; a_T_sec[5]=S5_sec;
  a_T_min[1]=S1_min; a_T_min[2]=S2_min; a_T_min[3]=S3_min; a_T_min[4]=S4_min; a_T_min[5]=S5_min;
  
  //---------------------Aggiornamento valori pagina iniziale----------------
  //T_int=a_T[Step_A];
  //T_sec=a_T_sec[Step_A];
  //T_min=a_T_min[Step_A]; 
  T_string=IntToString(T_int);
  
  avvio=1; //retroilluminazione su pagina iniziale

  //---------------------------Timer interrupt 1 sec---------------------------
  // initialize Timer1
  cli();          // disable global interrupts
  TCCR1A = 0;     // set entire TCCR1A register to 0
  TCCR1B = 0;     // same for TCCR1B
  
  // set compare match register to desired timer count:
  OCR1A = 15624;
  
  // turn on CTC mode:
  TCCR1B |= (1 << WGM12);
  
  // Set CS10 and CS12 bits for 1024 prescaler:
  TCCR1B |= (1 << CS10);
  TCCR1B |= (1 << CS12);
  
  // enable timer compare interrupt:
  TIMSK1 |= (1 << OCIE1A);
  
  // enable global interrupts:
  sei();
  }

ISR(TIMER1_COMPA_vect) // timer compare interrupt service routine
{
  if (Start){
   if (Clock1sec==LOW){
     Clock1sec=HIGH;
     refresh=HIGH;
     Temp_hold=Ta_int;
   }
   else{
    Clock1sec=LOW;
   }
  } 
}
	 

void loop() {
   
  //---------------------Aggiornamento valori step---------------------
  a_T[1]=T1_int; a_T[2]=T2_int; a_T[3]=T3_int; a_T[5]=T5_int;
  a_T_sec[1]=S1_sec; a_T_sec[2]=S2_sec; a_T_sec[3]=S3_sec; a_T_sec[4]=S4_sec; a_T_sec[5]=S5_sec;
  a_T_min[1]=S1_min; a_T_min[2]=S2_min; a_T_min[3]=S3_min; a_T_min[4]=S4_min; a_T_min[5]=S5_min;
  
 
  //---------------------Lettura stato pulsanti------------------------
  int P1_reading = digitalRead(i_P1);
  int P2_reading = digitalRead(i_P2);
  int P3_reading = digitalRead(i_P3);


  if (P1_reading != P1_lastButtonState) {  //lettura pulsante 1
    P1_lastDebounceTime = millis();
  } 
  
  if ((millis() - P1_lastDebounceTime) > debounceDelay) {
    P1_Stato = P1_reading;
  }
  
  P1_lastButtonState = P1_reading;
  
    if (P2_reading != P2_lastButtonState) {  //lettura pulsante 2
    P2_lastDebounceTime = millis();
  } 
  
  if ((millis() - P2_lastDebounceTime) > debounceDelay) {
    P2_Stato = P2_reading;
  }
  
  P2_lastButtonState = P2_reading;
  
  if (P3_reading != P3_lastButtonState) {  //lettura pulsante 3
    P3_lastDebounceTime = millis();
  } 
  
  if ((millis() - P3_lastDebounceTime) > debounceDelay) {
    P3_Stato = P3_reading;
  }
  
  P3_lastButtonState = P3_reading;
  
  //-------------------------Retroilluminazione-----------------------------------
  if (P1_Stato || (P2_Stato==LOW) || P3_Stato || (avvio==1)){    
    digitalWrite(o_Ri,HIGH);
    Retroilluminazione_On=1;
    ti_Retroilluminazione=millis();
    avvio=0;
  }
  if ( (avvio==0) && (int(millis()-ti_Retroilluminazione))>(Tempo_Ri*1000) ){
    digitalWrite(o_Ri,LOW);
    Retroilluminazione_On=0;
  }
  
  //----------------------------Contrasto----------------------------------------------
  analogWrite(o_Cs,(((100-contrasto)*255)/100));
  
  //---------------------------Salvataggio dati-----------------------------------------
 
 
  if (pagina!=0){ //salvo i dati su EEPROM ogni volta che arrivo su pagina 0
    pag0=LOW;
  }
  if ((pag0==LOW)&&(pagina==0)){
    EEPROMWrite=HIGH;
    pag0=HIGH;
  }
  if (EEPROMWrite==HIGH){
    memoria[0]=long(contrasto);
    memoria[4]=long(Tempo_Ri);
    memoria[8]=long(Step_I);
    memoria[12]=long(Step_F);
    memoria[16]=long(S1_sec);
    memoria[20]=long(S1_min);
    memoria[24]=long(S2_sec);
    memoria[28]=long(S2_min);
    memoria[32]=long(S3_sec);
    memoria[36]=long(S3_min);
    memoria[40]=long(S4_sec);
    memoria[44]=long(S4_min);
    memoria[48]=long(S5_sec);
    memoria[52]=long(S5_min);
    memoria[56]=long(T1_int);
    memoria[60]=long(T2_int);
    memoria[64]=long(T3_int);
    memoria[68]=long(T4_int);
    memoria[72]=long(T5_int);
    memoria[76]=long(T_int);
    memoria[80]=long(T_sec);
    memoria[84]=long(T_min); 
    memoria[88]=long(Step_A);
    memoria[92]=long(Tolleranza);
    memoria[96]=long(stato);
    memoria[100]=long(Tempo_R2);
    memoria[104]=long(Timeout);
    
    
    for (int EEPROMIndex=0; EEPROMIndex<=MaxEEPROM; EEPROMIndex+=4 ){
      EEPROMWriteInt(EEPROMIndex,memoria[EEPROMIndex]);
      if (EEPROMIndex==MaxEEPROM){
        EEPROMWrite=LOW;
      }
    }
  }
  
  //------------------------------Avanzamento pagine----------------------------------- 
  if ((P1_Stato==1) && (P1_pressed==0)) { 
    if (((pagina>=MaxPage) && (pagina<FirstSecretPage))||(pagina>=FirstAlarmPage)) {
      pagina=0;
    }
    else{
      if ((pagina>=(MaxSecretPage))&&(pagina<FirstAlarmPage)){
        pagina=FirstSecretPage;
      }
      else{  
        pagina=pagina+1;
      }  
    }
    lcd.clear();    
    P1_pressed=1;
    ti = millis();
  }
  
  if ((P1_Stato==0) && (P1_pressed==1)){
     P1_pressed=0;
     P1_long=0;
     ti=0;
  }
  
  //------------------------------Passaggio a menù segreto-------------------------------------
  
  if ((P1_pressed==1) && ((millis()-ti)>=5000) && (P1_long==0)){     
    if (offset_p==50){
      offset_p=0;   
      pagina=0+offset_p;    
      lcd.clear();   
    }  
    else{
      offset_p=50;
      pagina=0+offset_p;
      lcd.clear(); 
    }

    ti=0;  
    P1_long=1;
  }
  

  
  //----------------------Gestione pagine------------------------------
  
  switch (pagina) {
    
    //----------------------Pagine menu normale------------------------------
    
    case 0:   
      
      T_string=IntToString(T_int);
      lcd.setCursor(0, 0);  // colonna, riga
      lcd.print("S=");
      lcd.print(T_string);
      lcd.setCursor(10, 0);  // colonna, riga
      lcd.print("M=");
      printDouble(Temp, 1);
      lcd.setCursor(0, 1);  // colonna, riga
      lcd.print("St=");
      lcd.print(Step_A);
      lcd.setCursor(6, 1);  // colonna, riga
      lcd.print(On_Off);
      lcd.setCursor(11, 1);  // colonna, riga
      
      lcd.print(displayTime(T_min, T_sec));
        
      lcd.setCursor(7, 0);      
      if (R1_on){
        lcd.print(char(219));
      }  
      else{
        lcd.print(" "); 
      }  
      
      lcd.setCursor(8, 0);  
      if (R2_on){
        lcd.print(char(219));
      }
      else{
        lcd.print(" ");
      }

           
      
      if ((P3_Stato) && (P3_Temp_s==LOW)) {
        if (Start){
          Start=LOW;
          On_Off="OFF";
        }
        else{
          Start=HIGH;
          On_Off="ON ";
        }
        P3_Temp_s=HIGH;
      } 
      if ((P3_Stato==LOW)&&(P3_Temp_s==HIGH)){
        P3_Temp_s=LOW;
      }  
      break;
      
    case 1:
      lcd.setCursor(0, 0);  // colonna, riga
      lcd.print("First step= ");
      lcd.print(Step_I);
      lcd.setCursor(0, 1);  // colonna, riga
      lcd.print("Last  step= ");
      lcd.print(Step_F);
      
      if ((P2_Stato==LOW) && (P2_Temp==LOW)) { 
        if (Step_I<5){
          Step_I=Step_I+1;
          P2_Temp=HIGH;
          P2_ti_temp=millis(); 
          lcd.clear();
        }  
        else{
          Step_I=0;
        }  
        //aggiornamento valori caricati
        T_int=a_T[Step_I];
        T_string=IntToString(T_int);
        T_sec=a_T_sec[Step_I];
        T_min=a_T_min[Step_I];
        Step_A=Step_I;
        stato=0;
      }
      
      if ((P3_Stato) && (P3_Temp==LOW)) {
        if (Step_F<5){
          Step_F=Step_F+1;
          P3_Temp=HIGH;
          P3_ti_temp=millis(); 
          lcd.clear();
        }  
        else{
          Step_F=0;
        }   
        //aggiornamento valori caricati
        T_int=a_T[Step_I];
        T_string=IntToString(T_int);
        T_sec=a_T_sec[Step_I];
        T_min=a_T_min[Step_I];
        Step_A=Step_I;
        stato=0;   
      }
     
      
      break;
      
    
    case 2:
      lcd.setCursor(5, 0);  // colonna, riga
      lcd.print("Step 1");
      lcd.setCursor(3, 1);  // colonna, riga
      lcd.print("Time=");
      lcd.print(displayTime(S1_min, S1_sec));
   
      if ((P2_Stato==LOW) && (P2_Temp==LOW)) { //decremento
        if (S1_sec_temp>0){
          S1_sec_temp=S1_sec_temp-offset_v;
          P2_Temp=HIGH;
          P2_ti_temp=millis(); 
          lcd.clear();
        } 
        else{
          if (S1_min_temp<=0){
            S1_sec_temp=0;
            S1_min_temp=0;
          }
          else{
            S1_sec_temp=59;
          }
        }  
        if (S1_sec_temp==59){
          S1_min_temp=S1_min_temp-offset_v;
        }
        
        if (S1_sec_temp<0){  //aggiornamento valori
          S1_sec=0;
        }  
        else{
            if (S1_sec_temp>59){
              S1_sec=59;
            }  
            else{
              S1_sec=S1_sec_temp;
            } 
        }
        
        if (S1_min_temp<0){
          S1_min=0;
        }  
        else{
            if (S1_min_temp>99){
              S1_min=99;
            }  
            else{
              S1_min=S1_min_temp;
            } 
        }      
      }  
      
      if ((P3_Stato) && (P3_Temp==LOW)) {  //incremento
        if (S1_sec_temp<59){
          S1_sec_temp=S1_sec_temp+offset_v;
          P3_Temp=HIGH;
          P3_ti_temp=millis(); 
          lcd.clear();
        }
        else{
          if (S1_min_temp>=99){
            S1_sec_temp=59;
            S1_min_temp=99;
          }
          else{
            S1_sec_temp=0;
          }             
        }  
        if (S1_sec_temp==0){
          S1_min_temp=S1_min_temp+offset_v;
        } 
      
        if (S1_sec_temp<0){  //aggiornamento valori
          S1_sec=0;
        }  
        else{
            if (S1_sec_temp>59){
              S1_sec=59;
            }  
            else{
              S1_sec=S1_sec_temp;
            } 
        }
        
        if (S1_min_temp<0){
          S1_min=0;
        }  
        else{
            if (S1_min_temp>99){
              S1_min=99;
            }  
            else{
              S1_min=S1_min_temp;
            } 
        }      
      }  
      break;
      
    case 3:
      T1_string=IntToString(T1_int);
      lcd.setCursor(5, 0);  // colonna, riga
      lcd.print("Step 1");
      lcd.setCursor(2, 1);  // colonna, riga
      lcd.print("Temp=");
      lcd.print(T1_string);
      lcd.print(" ");
      lcd.print(char(223));
      lcd.print("C");
            
      if ((P2_Stato==LOW) && (P2_Temp==LOW)) {
        if (T1_int>0){
          T1_int=T1_int-offset_v;
          P2_Temp=HIGH;
          P2_ti_temp=millis(); 
          lcd.clear();
        }  
        else{
          T1_int=0;
        }  
      }
      if ((P3_Stato) && (P3_Temp==LOW)) {
        if (T1_int<999){
          T1_int=T1_int+offset_v;
          P3_Temp=HIGH;
          P3_ti_temp=millis(); 
          lcd.clear();
        }
        else{
          T1_int=999;
        }  
      }
      break;  
      
    case 4:
      lcd.setCursor(5, 0);  // colonna, riga
      lcd.print("Step 2");
      lcd.setCursor(3, 1);  // colonna, riga
      lcd.print("Time=");
      lcd.print(displayTime(S2_min, S2_sec));
      
      if ((P2_Stato==LOW) && (P2_Temp==LOW)) { //decremento
        if (S2_sec_temp>0){
          S2_sec_temp=S2_sec_temp-offset_v;
          P2_Temp=HIGH;
          P2_ti_temp=millis(); 
          lcd.clear();
        } 
        else{
          if (S2_min_temp<=0){
            S2_sec_temp=0;
            S2_min_temp=0;
          }
          else{
            S2_sec_temp=59;
          }
        }  
        if (S2_sec_temp==59){
          S2_min_temp=S2_min_temp-offset_v;
        }
        
        if (S2_sec_temp<0){  //aggiornamento valori
          S2_sec=0;
        }  
        else{
            if (S2_sec_temp>59){
              S2_sec=59;
            }  
            else{
              S2_sec=S2_sec_temp;
            } 
        }
        
        if (S2_min_temp<0){
          S2_min=0;
        }  
        else{
            if (S2_min_temp>99){
              S2_min=99;
            }  
            else{
              S2_min=S2_min_temp;
            } 
        }      
      }  
      
      if ((P3_Stato) && (P3_Temp==LOW)) {  //incremento
        if (S2_sec_temp<59){
          S2_sec_temp=S2_sec_temp+offset_v;
          P3_Temp=HIGH;
          P3_ti_temp=millis(); 
          lcd.clear();
        }
        else{
          if (S2_min_temp>=99){
            S2_sec_temp=59;
            S2_min_temp=99;
          }
          else{
            S2_sec_temp=0;
          }             
        }  
        if (S2_sec_temp==0){
          S2_min_temp=S2_min_temp+offset_v;
        } 
      
        if (S2_sec_temp<0){  //aggiornamento valori
          S2_sec=0;
        }  
        else{
            if (S2_sec_temp>59){
              S2_sec=59;
            }  
            else{
              S2_sec=S2_sec_temp;
            } 
        }
        
        if (S2_min_temp<0){
          S2_min=0;
        }  
        else{
            if (S2_min_temp>99){
              S2_min=99;
            }  
            else{
              S2_min=S2_min_temp;
            } 
        }      
      }  
      break;
      
    case 5:
      T2_string=IntToString(T2_int);
      lcd.setCursor(5, 0);  // colonna, riga
      lcd.print("Step 2");
      lcd.setCursor(2, 1);  // colonna, riga
      lcd.print("Temp=");
      lcd.print(T2_string);
      lcd.print(" ");
      lcd.print(char(223));
      lcd.print("C");
      
      if ((P2_Stato==LOW) && (P2_Temp==LOW)) {
        if (T2_int>0){
          T2_int=T2_int-offset_v;
          P2_Temp=HIGH;
          P2_ti_temp=millis(); 
          lcd.clear();
        }  
        else{
          T2_int=0;
        }  
      }
      if ((P3_Stato) && (P3_Temp==LOW)) {
        if (T2_int<999){
          T2_int=T2_int+offset_v;
          P3_Temp=HIGH;
          P3_ti_temp=millis(); 
          lcd.clear();
        }
        else{
          T2_int=999;
        }  
      }
      break;    
      
    case 6:
      lcd.setCursor(5, 0);  // colonna, riga
      lcd.print("Step 3");
      lcd.setCursor(3, 1);  // colonna, riga
      lcd.print("Time=");
      lcd.print(displayTime(S3_min, S3_sec));
      
      if ((P2_Stato==LOW) && (P2_Temp==LOW)) { //decremento
        if (S3_sec_temp>0){
          S3_sec_temp=S3_sec_temp-offset_v;
          P2_Temp=HIGH;
          P2_ti_temp=millis(); 
          lcd.clear();
        } 
        else{
          if (S3_min_temp<=0){
            S3_sec_temp=0;
            S3_min_temp=0;
          }
          else{
            S3_sec_temp=59;
          }
        }  
        if (S3_sec_temp==59){
          S3_min_temp=S1_min_temp-offset_v;
        }
        
        if (S3_sec_temp<0){  //aggiornamento valori
          S3_sec=0;
        }  
        else{
            if (S3_sec_temp>59){
              S3_sec=59;
            }  
            else{
              S3_sec=S3_sec_temp;
            } 
        }
        
        if (S3_min_temp<0){
          S3_min=0;
        }  
        else{
            if (S3_min_temp>99){
              S3_min=99;
            }  
            else{
              S3_min=S3_min_temp;
            } 
        }      
      }  
      
      if ((P3_Stato) && (P3_Temp==LOW)) {  //incremento
        if (S3_sec_temp<59){
          S3_sec_temp=S3_sec_temp+offset_v;
          P3_Temp=HIGH;
          P3_ti_temp=millis(); 
          lcd.clear();
        }
        else{
          if (S3_min_temp>=99){
            S3_sec_temp=59;
            S3_min_temp=99;
          }
          else{
            S3_sec_temp=0;
          }             
        }  
        if (S3_sec_temp==0){
          S3_min_temp=S3_min_temp+offset_v;
        } 
      
        if (S3_sec_temp<0){  //aggiornamento valori
          S3_sec=0;
        }  
        else{
            if (S3_sec_temp>59){
              S3_sec=59;
            }  
            else{
              S3_sec=S3_sec_temp;
            } 
        }
        
        if (S3_min_temp<0){
          S3_min=0;
        }  
        else{
            if (S3_min_temp>99){
              S3_min=99;
            }  
            else{
              S3_min=S3_min_temp;
            } 
        }      
      }  
      break;
      
    case 7:
      T3_string=IntToString(T3_int);
      lcd.setCursor(5, 0);  // colonna, riga
      lcd.print("Step 3");
      lcd.setCursor(2, 1);  // colonna, riga
      lcd.print("Temp=");
      lcd.print(T3_string);
      lcd.print(" ");
      lcd.print(char(223));
      lcd.print("C");
      
      if ((P2_Stato==LOW) && (P2_Temp==LOW)) {
        if (T3_int>0){
          T3_int=T3_int-offset_v;
          P2_Temp=HIGH;
          P2_ti_temp=millis(); 
          lcd.clear();
        }  
        else{
          T3_int=0;
        }  
      }
      if ((P3_Stato) && (P3_Temp==LOW)) {
        if (T3_int<999){
          T3_int=T3_int+offset_v;
          P3_Temp=HIGH;
          P3_ti_temp=millis(); 
          lcd.clear();
        }
        else{
          T3_int=999;
        }  
      }
      break;   
     
     case 8:
      lcd.setCursor(5, 0);  // colonna, riga
      lcd.print("Step 4");
      lcd.setCursor(3, 1);  // colonna, riga
      lcd.print("Time=");
      lcd.print(displayTime(S4_min, S4_sec));
      
      if ((P2_Stato==LOW) && (P2_Temp==LOW)) { //decremento
        if (S4_sec_temp>0){
          S4_sec_temp=S4_sec_temp-offset_v;
          P2_Temp=HIGH;
          P2_ti_temp=millis(); 
          lcd.clear();
        } 
        else{
          if (S4_min_temp<=0){
            S4_sec_temp=0;
            S4_min_temp=0;
          }
          else{
            S4_sec_temp=59;
          }
        }  
        if (S4_sec_temp==59){
          S4_min_temp=S4_min_temp-offset_v;
        }
        
        if (S4_sec_temp<0){  //aggiornamento valori
          S4_sec=0;
        }  
        else{
            if (S4_sec_temp>59){
              S4_sec=59;
            }  
            else{
              S4_sec=S4_sec_temp;
            } 
        }
        
        if (S4_min_temp<0){
          S4_min=0;
        }  
        else{
            if (S4_min_temp>99){
              S4_min=99;
            }  
            else{
              S4_min=S4_min_temp;
            } 
        }      
      }  
      
      if ((P3_Stato) && (P3_Temp==LOW)) {  //incremento
        if (S4_sec_temp<59){
          S4_sec_temp=S4_sec_temp+offset_v;
          P3_Temp=HIGH;
          P3_ti_temp=millis(); 
          lcd.clear();
        }
        else{
          if (S4_min_temp>=99){
            S4_sec_temp=59;
            S4_min_temp=99;
          }
          else{
            S4_sec_temp=0;
          }             
        }  
        if (S4_sec_temp==0){
          S4_min_temp=S4_min_temp+offset_v;
        } 
      
        if (S4_sec_temp<0){  //aggiornamento valori
          S4_sec=0;
        }  
        else{
            if (S4_sec_temp>59){
              S4_sec=59;
            }  
            else{
              S4_sec=S4_sec_temp;
            } 
        }
        
        if (S4_min_temp<0){
          S4_min=0;
        }  
        else{
            if (S4_min_temp>99){
              S4_min=99;
            }  
            else{
              S4_min=S4_min_temp;
            } 
        }      
      }  
      break;
      
    case 9:
      T4_string=IntToString(T4_int);
      lcd.setCursor(5, 0);  // colonna, riga
      lcd.print("Step 4");
      lcd.setCursor(2, 1);  // colonna, riga
      lcd.print("Temp=");
      lcd.print(T4_string);
      lcd.print(" ");
      lcd.print(char(223));
      lcd.print("C");
      if ((P2_Stato==LOW) && (P2_Temp==LOW)) {
        if (T4_int>0){
          T4_int=T4_int-offset_v;
          P2_Temp=HIGH;
          P2_ti_temp=millis(); 
          lcd.clear();
        }  
        else{
          T4_int=0;
        }  
      }
      if ((P3_Stato) && (P3_Temp==LOW)) {
        if (T4_int<999){
          T4_int=T4_int+offset_v;
          P3_Temp=HIGH;
          P3_ti_temp=millis(); 
          lcd.clear();
        }
        else{
          T4_int=999;
        }  
      }
      break;  
     
     case 10:
      lcd.setCursor(5, 0);  // colonna, riga
      lcd.print("Step 5");
      lcd.setCursor(3, 1);  // colonna, riga
      lcd.print("Time=");
      lcd.print(displayTime(S5_min, S5_sec));
      
      if ((P2_Stato==LOW) && (P2_Temp==LOW)) { //decremento
        if (S5_sec_temp>0){
          S5_sec_temp=S5_sec_temp-offset_v;
          P2_Temp=HIGH;
          P2_ti_temp=millis(); 
          lcd.clear();
        } 
        else{
          if (S5_min_temp<=0){
            S5_sec_temp=0;
            S5_min_temp=0;
          }
          else{
            S5_sec_temp=59;
          }
        }  
        if (S5_sec_temp==59){
          S5_min_temp=S5_min_temp-offset_v;
        }
        
        if (S5_sec_temp<0){  //aggiornamento valori
          S5_sec=0;
        }  
        else{
            if (S5_sec_temp>59){
              S5_sec=59;
            }  
            else{
              S5_sec=S5_sec_temp;
            } 
        }
        
        if (S5_min_temp<0){
          S5_min=0;
        }  
        else{
            if (S5_min_temp>99){
              S5_min=99;
            }  
            else{
              S5_min=S5_min_temp;
            } 
        }      
      }  
      
      if ((P3_Stato) && (P3_Temp==LOW)) {  //incremento
        if (S5_sec_temp<59){
          S5_sec_temp=S5_sec_temp+offset_v;
          P3_Temp=HIGH;
          P3_ti_temp=millis(); 
          lcd.clear();
        }
        else{
          if (S5_min_temp>=99){
            S5_sec_temp=59;
            S5_min_temp=99;
          }
          else{
            S5_sec_temp=0;
          }             
        }  
        if (S5_sec_temp==0){
          S5_min_temp=S5_min_temp+offset_v;
        } 
      
        if (S5_sec_temp<0){  //aggiornamento valori
          S5_sec=0;
        }  
        else{
            if (S5_sec_temp>59){
              S5_sec=59;
            }  
            else{
              S5_sec=S5_sec_temp;
            } 
        }
        
        if (S5_min_temp<0){
          S5_min=0;
        }  
        else{
            if (S5_min_temp>99){
              S5_min=99;
            }  
            else{
              S5_min=S5_min_temp;
            } 
        }      
      }  
      break;
      
    case 11:
      T5_string=IntToString(T5_int);
      lcd.setCursor(5, 0);  // colonna, riga
      lcd.print("Step 5");
      lcd.setCursor(2, 1);  // colonna, riga
      lcd.print("Temp=");
      lcd.print(T5_string);
      lcd.print(" ");
      lcd.print(char(223));
      lcd.print("C");
      
      if ((P2_Stato==LOW) && (P2_Temp==LOW)) {
        if (T5_int>0){
          T5_int=T5_int-offset_v;
          P2_Temp=HIGH;
          P2_ti_temp=millis(); 
          lcd.clear();
        }  
        else{
          T5_int=0;
        }  
      }
      if ((P3_Stato) && (P3_Temp==LOW)) {
        if (T5_int<999){
          T5_int=T5_int+offset_v;
          P3_Temp=HIGH;
          P3_ti_temp=millis(); 
          lcd.clear();
        }
        else{
          T5_int=999;
        }  
      }
      break;  
    
      
    //----------------------Pagine menu segreto------------------------------   
      
    case 50:
      lcd.setCursor(3, 0);  // colonna, riga
      lcd.print("Backlight");
      lcd.setCursor(6, 1);  // colonna, riga
      lcd.print(Tempo_Ri);
      lcd.print(" s");
      
      if ((P2_Stato==LOW) && (P2_Temp==LOW)) {
        if (Tempo_Ri>0){
          Tempo_Ri=Tempo_Ri-offset_v;
          P2_Temp=HIGH;
          P2_ti_temp=millis(); 
          lcd.clear();
        }  
        else{
          Tempo_Ri=0;
        }  
      }
      if ((P3_Stato) && (P3_Temp==LOW)) {
        if (Tempo_Ri<160){
          Tempo_Ri=Tempo_Ri+offset_v;
          P3_Temp=HIGH;
          P3_ti_temp=millis(); 
          lcd.clear();
        }
        else{
          Tempo_Ri=160;
        }  
      }
      break; 
      
    case 51:
      Tolleranza_string=IntToString(Tolleranza);
      lcd.setCursor(3, 0);  // colonna, riga
      lcd.print("Tolerance");
      lcd.setCursor(4, 1);  // colonna, riga
      lcd.print(Tolleranza_string); 
      lcd.print(" ");
      lcd.print(char(223));
      lcd.print("C");
      
      if ((P2_Stato==LOW) && (P2_Temp==LOW)) {
        if (Tolleranza>0){
          Tolleranza=Tolleranza-offset_v;
          P2_Temp=HIGH;
          P2_ti_temp=millis(); 
          lcd.clear();
        }  
        else{
          Tolleranza=0;
        }  
      }
      if ((P3_Stato) && (P3_Temp==LOW)) {
        if (Tolleranza<20){
          Tolleranza=Tolleranza+offset_v;
          P3_Temp=HIGH;
          P3_ti_temp=millis(); 
          lcd.clear();
        }
        else{
          Tolleranza=20;
        }  
      }
      break;
      
    case 52:
      f_Manuali=HIGH;
      lcd.setCursor(3, 0);  // colonna, riga
      lcd.print("R1  R2  R3");
      lcd.setCursor(3, 1);  // colonna, riga
      if (rele_index==1){
        lcd.print(Rele[1]); 
        lcd.setCursor(3, 1);
        lcd.blink();
        delay(50);
      }  
      else{
        lcd.print(Rele[1]); 
      }
      lcd.setCursor(7, 1);  // colonna, riga
      if (rele_index==2){
        lcd.print(Rele[2]); 
        lcd.setCursor(7, 1);
        lcd.blink();
        delay(50);
      }  
      else{
        lcd.print(Rele[2]); 
      }
      lcd.setCursor(11, 1);  // colonna, riga
      if (rele_index==3){
        lcd.print(Rele[3]); 
        lcd.setCursor(11, 1);
        lcd.blink();
        delay(50);
      }  
      else{
        lcd.print(Rele[3]); 
      }

      if ((P2_Stato==LOW) && (P2_Temp==LOW)) {
        if (rele_index<3){
          rele_index=rele_index+1;
          P2_Temp=HIGH;
          P2_ti_temp=millis(); 
          lcd.clear();
        }
        else{
          rele_index=1;
          P2_Temp=HIGH;
          P2_ti_temp=millis(); 
          lcd.clear();
        }  
      }
      
      if ((P3_Stato) && (P3_Temp==LOW)) {
        if (Rele[rele_index]==LOW){
           Rele[rele_index]=HIGH;
           P3_Temp=HIGH;
           P3_ti_temp=millis(); 
           lcd.clear();
        }  
        else{
          Rele[rele_index]=LOW;
          P3_Temp=HIGH;
          P3_ti_temp=millis(); 
          lcd.clear();
        }  
      }
      break;
      
      case 53:
      lcd.setCursor(3, 0);  // colonna, riga
      lcd.print("R2 On time");
      lcd.setCursor(6, 1);  // colonna, riga
      lcd.print(Tempo_R2);
      lcd.print(" s");
      
      if ((P2_Stato==LOW) && (P2_Temp==LOW)) {
        if (Tempo_R2>0){
          Tempo_R2=Tempo_R2-offset_v;
          P2_Temp=HIGH;
          P2_ti_temp=millis(); 
          lcd.clear();
        }  
        else{
          Tempo_R2=0;
        }  
      }
      if ((P3_Stato) && (P3_Temp==LOW)) {
        if (Tempo_R2<160){
          Tempo_R2=Tempo_R2+offset_v;
          P3_Temp=HIGH;
          P3_ti_temp=millis(); 
          lcd.clear();
        }
        else{
          Tempo_R2=999;
        }  
      }
      break; 
      
      case 54:
      lcd.setCursor(4, 0);  // colonna, riga
      lcd.print("Timeout");
      lcd.setCursor(6, 1);  // colonna, riga
      lcd.print(Timeout_string);
      lcd.print(" s");
      
      if ((P2_Stato==LOW) && (P2_Temp==LOW)) {
        if (Timeout>0){
          Timeout=Timeout-offset_v;
          P2_Temp=HIGH;
          P2_ti_temp=millis(); 
          lcd.clear();
          No_timeout=LOW;  
        }  
        else{
          //Timeout=0;
          No_timeout=HIGH;
          Timeout=-1; 
        }  
      }
      if ((P3_Stato) && (P3_Temp==LOW)) {
        if (Timeout<160){
          Timeout=Timeout+offset_v;
          P3_Temp=HIGH;
          P3_ti_temp=millis(); 
          lcd.clear();
          No_timeout=LOW;       
        }
        else{
          Timeout=999;
          No_timeout=LOW;  
        }  
      }
      
      if (Timeout==-1){
        Timeout_string="-";
      }
      else{
        Timeout_string=String(Timeout);
      }
      
      break; 
 
    //----------------------Pagine allarmi------------------------------   
      
    case 100:
      lcd.setCursor(5, 0);  // colonna, riga
      lcd.print("Alarm");
      lcd.setCursor(4, 1);  // colonna, riga
      lcd.print("Timeout");
  
      if ((P3_Stato) && (P3_Temp_s==LOW)) {
        offset_p=0; 
        pagina=0;
        lcd.clear();
        P3_Temp_s=HIGH;
      } 
      if ((P3_Stato==LOW)&&(P3_Temp_s==HIGH)){
        P3_Temp_s=LOW;
      }    
      
      if ((P2_Stato==LOW) && (P2_Temp_s==LOW)) {
        offset_p=0; 
        pagina=0;
        lcd.clear();
        P2_Temp_s=HIGH;
      } 
      if ((P2_Stato==HIGH)&&(P2_Temp_s==HIGH)){
        P2_Temp_s=LOW;
      }    
      
      if ((P1_Stato) && (P1_Temp_s==LOW)) {
        ti=millis();
        offset_p=0; 
        pagina=0;
        lcd.clear();
        P1_Temp_s=HIGH;
      } 
      if ((P1_Stato==LOW)&&(P1_Temp_s==HIGH)){
        P1_Temp_s=LOW;
      }    
      break;
 
      
  } 
  
  //----------------Reset memoria pulsante premuto-----------
  if ((P2_Stato==LOW) && ((millis()-P2_ti_temp>=delay_p)&&(P2_ti_temp_p<delay_pp)) ){ //decremento veloce
    P2_Temp=LOW;
    offset_v=1;
    P2_ti_temp_p=P2_ti_temp_p+(millis()-P2_ti_temp);
  }
  if ((P2_Stato==LOW) && (P2_ti_temp_p>=delay_pp) && (P2_jump==LOW)){ //abilitazione decremento 10 con pressione > 1s
    P2_delay_pp=millis();
    P2_jump=HIGH;
  }
  if ((P2_Stato==LOW) && ((millis()-P2_delay_pp)>1000) && (P2_jump==HIGH)){ //decremento 10
    P2_Temp=LOW;
    offset_v=10;
    P2_delay_pp=millis();
  }
  
  if ((P2_Stato==HIGH) && (P2_jump==LOW)) { //reset decremento normale e veloce
    P2_Temp=LOW;
    P2_ti_temp_p=0;
  }
  
  if ((P2_Stato==HIGH) && (P2_jump==HIGH)) { //reset decremento 10
    P2_Temp=LOW;
    offset_v=1;
    P2_ti_temp_p=0;
    P2_jump=LOW;
  }
  
  if ((P3_Stato==HIGH) && ((millis()-P3_ti_temp>=delay_p)&&(P3_ti_temp_p<delay_pp)) ){
    P3_Temp=LOW;
    offset_v=1;
    P3_ti_temp_p=P3_ti_temp_p+(millis()-P3_ti_temp);
  }
  if ((P3_Stato==HIGH) && (P3_ti_temp_p>=delay_pp) && (P3_jump==LOW)){
    P3_delay_pp=millis();
    P3_jump=HIGH; 
  }
  if ((P3_Stato==HIGH) && ((millis()-P3_delay_pp)>1000) && (P3_jump==HIGH)){
    P3_Temp=LOW;
    offset_v=10;
    P3_delay_pp=millis();
  }
  
  if ((P3_Stato==LOW) && (P3_jump==LOW)) {
    P3_Temp=LOW;
    P3_ti_temp_p=0;
  }
  
  if ((P3_Stato==LOW) && (P3_jump==HIGH)) {
    P3_Temp=LOW;
    offset_v=1;
    P3_ti_temp_p=0;
    P3_jump=LOW;
  }
  
  //----------------Reset funzioni manuali---------------
  if ((pagina!=52)&&(f_Manuali)){
     Rele[1]=LOW;
     Rele[2]=LOW;
     Rele[3]=LOW;
     f_Manuali=LOW;
  }
  
  
  //----------------Aggiornamento temperatura---------------
  Temp=Thermistor(analogRead(i_NTC), index, A, B, C);           // read ADC and convert it to Celsius
 
  Ta_int=int(Temp*10);

  //---------------------------Stati------------------------
  if (Start) {
  
    switch (stato) {
     case 0: //Controllo step attuale
       if (Step_A<=Step_F){
         stato=1;
       }
       else{
         Start=0;
         On_Off="OFF";
         //aggiornamento valori caricati
         T_int=a_T[Step_I];
         T_string=IntToString(T_int);
         T_sec=a_T_sec[Step_I];
         T_min=a_T_min[Step_I];
         Step_A=Step_I;
         memoria[76]=long(T_int);
         memoria[80]=long(T_sec);
         memoria[84]=long(T_min); 
         memoria[88]=long(Step_A);
         memoria[96]=long(stato);
         EEPROMWrite=HIGH;
         stato=0;
       }
       break;
     case 1: //Controllo temperatura iniziale
       if (Ta_int >= T_int){
         stato=2;
       }
       break;
     case 2: //Controllo tempo
      if (Clock1sec) {
       if (T_sec <= 0){
        if (T_min <=0){
          stato=3;
        }
        else{
          T_min=T_min-1;
          T_sec=59;  
          memoria[76]=long(T_int);
          memoria[80]=long(T_sec);
          memoria[84]=long(T_min); 
          memoria[88]=long(Step_A);
          memoria[96]=long(stato);
          EEPROMWrite=HIGH;
          Clock1sec=LOW;
        }  
          }
       else{
         T_sec=T_sec-1;
         Clock1sec=LOW;
       }
      } 
      break;  
     case 3: //Aggiornamento stato
       Step_A=Step_A+1;
       T_min=a_T_min[Step_A];
       T_sec=a_T_sec[Step_A];
       T_int=a_T[Step_A];
       stato=0;
       memoria[76]=long(T_int);
       memoria[80]=long(T_sec);
       memoria[84]=long(T_min); 
       memoria[88]=long(Step_A);
       memoria[96]=long(stato);
       EEPROMWrite=HIGH;
       break;     
    }  
      
    if (stato==1){
       if (Ta_int<T_int){ //controllo temp
        digitalWrite(o_R1,HIGH);
        R1_on=HIGH;
      } 
    }
    else{
      if (Ta_int<(T_int-Tolleranza)){ //controllo temp
        R1_on=HIGH;
      }
    } 
      
    
    if (Ta_int>=T_int){
      R1_on=LOW;
      R2_start=LOW;
    }
    
    //-----------------------------------------Gestione R2---------------------------------------
  
    if((R1_on==HIGH)&&(R2_start==LOW)){
      time_R2_I=millis();
      R2_start=HIGH;
    }
    
    if ((R2_start)&&((millis()-time_R2_I)<long(Tempo_R2*1000))){
      R2_on=HIGH;
      R2_start=HIGH;
    }
    if ((R2_start)&&((millis()-time_R2_I)>=long(Tempo_R2*1000))){
      R2_on=LOW;
      R2_start=HIGH;
    }   
    if (R1_on==LOW){
      R2_on=LOW;
      R2_start=LOW;
    }   
    
  }
  else{
    R1_on=LOW;
    R2_on=LOW;
    R2_start=LOW;  
  }
  
//------------------------------------Uscite-------------------------------------------
  digitalWrite(o_R1,((R1_on)||(Rele[1])));
  digitalWrite(o_R2,((R2_on)||(Rele[2])));
  digitalWrite(o_R3,((R3_on)||(Rele[3])));
 
//-------------------------------------Timeout------------------------------------------
  
  if (No_timeout){
    Timeout_start=LOW;
  }
  else{  
    if((R1_on==HIGH)&&((Ta_int<=(Temp_hold+2))&&(Ta_int>=(Temp_hold-2)))&&(Timeout_start==LOW)){
      time_Timeout_I=millis();
      Timeout_start=HIGH;
    }
    if(((R1_on==HIGH)&&((Ta_int>(Temp_hold+2))||(Ta_int<(Temp_hold-2))))||(R1_on==LOW)){
      Timeout_start=LOW;
    }
       
    if ((Timeout_start)&&((millis()-time_Timeout_I)>long(Timeout*1000))){
      lcd.clear(); 
      pagina=100;
      Start=LOW;
      On_Off="OFF";
      Timeout_start=LOW;
      avvio=1;
    }
  }  
}
    
   
//--------------------------------------------Funzioni---------------------------------------

double Thermistor(int RawADC, int index, double A[3], double B[3], double C[3]) {
 // Inputs ADC Value from Thermistor and outputs Temperature in Celsius
 //  requires: include <math.h>
 // Utilizes the Steinhart-Hart Thermistor Equation:
 //    Temperature in Kelvin = 1 / {A + B[ln(R)] + C[ln(R)]^3}
 //    where A = 0.001129148, B = 0.000234125 and C = 8.76741E-08
 long Resistance;  double Temp;  // Dual-Purpose variable to save space.
 Resistance=((10240000/RawADC) - 10000);  // Assuming a 10k Thermistor.  Calculation is actually: Resistance = (1024 * BalanceResistor/ADC) - BalanceResistor
 Temp = log(Resistance); // Saving the Log(resistance) so not to calculate it 4 times later. // "Temp" means "Temporary" on this line.
 Temp = 1 / (A[index] + (B[index] * Temp) + (C[index] * Temp * Temp * Temp));   // Now it means both "Temporary" and "Temperature"
 Temp = Temp - 273.15;  // Convert Kelvin to Celsius                                         // Now it only means "Temperature"

 // Uncomment this line for the function to return Fahrenheit instead.
 //Temp = (Temp * 9.0)/ 5.0 + 32.0; // Convert to Fahrenheit
 return Temp;  // Return the Temperature
}

void printDouble(double val, byte precision) {
  // prints val with number of decimal places determine by precision
  // precision is a number from 0 to 6 indicating the desired decimal places
  // example: printDouble(3.1415, 2); // prints 3.14 (two decimal places)
  lcd.print (int(val));  //prints the int part
  if( precision > 0) {
    unsigned long frac, mult = 1;
    byte padding = precision -1;
    while(precision--) mult *=10;
    if(val >= 0) frac = (val - int(val)) * mult; else frac = (int(val) - val) * mult;
    unsigned long frac1 = frac;
    while(frac1 /= 10) padding--;
    lcd.print(".");
    while(padding--) lcd.print("0");
    lcd.print(frac,DEC) ;
  }
}  

void EEPROMWriteInt(int p_address, long p_value)
{
  byte Byte1 = ((p_value >> 0) & 0xFF);
  byte Byte2 = ((p_value >> 8) & 0xFF);
  byte Byte3 = ((p_value >> 16) & 0xFF);
  byte Byte4 = ((p_value >> 24) & 0xFF);

  EEPROM.write(p_address, Byte1);
  EEPROM.write(p_address + 1, Byte2);
  EEPROM.write(p_address + 2, Byte3);
  EEPROM.write(p_address + 3, Byte4);
}


long EEPROMReadInt(int p_address){
  byte Byte1 = EEPROM.read(p_address);
  byte Byte2 = EEPROM.read(p_address + 1);
  byte Byte3 = EEPROM.read(p_address + 2);
  byte Byte4 = EEPROM.read(p_address + 3);

  long firstTwoBytes = ((Byte1 << 0) & 0xFF) + ((Byte2 << 8) & 0xFF00);
  long secondTwoBytes = (((Byte3 << 0) & 0xFF) + ((Byte4 << 8) & 0xFF00));
  secondTwoBytes *= 65536; // multiply by 2 to power 16 - bit shift 24 to the left

  return (firstTwoBytes + secondTwoBytes);
}  

String IntToString(int value){
  int centinaia=value/100;
  int decine=(value-(centinaia*100))/10;
  int unita=value-(centinaia*100)-(decine*10);
  return(String(centinaia)+String(decine)+"."+String(unita));
}

String displayTime(int t_min, int t_sec){
  int decina_min=t_min/10;
  int unita_min=t_min-(decina_min*10);
  int decina_sec=t_sec/10;
  int unita_sec=t_sec-(decina_sec*10);
  return (String(decina_min)+String(unita_min)+String(":")+String(decina_sec)+String(unita_sec));
  
}




  


